import _extends from "@babel/runtime/helpers/esm/extends";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { PureComponent } from 'react';
import FormCheckbox from '@s-ui/react-form-checkbox';
var BASE_CLASS = 'sui-FormCheckboxesWithParent';

var FormCheckboxesWithParent = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(FormCheckboxesWithParent, _PureComponent);

  function FormCheckboxesWithParent() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    _this.state = {
      childrenCheckbox: [].concat(_this.props.initialChildrenCheckbox)
    };

    _this._createHandleChangeParent = function (checked) {
      return function () {
        var newChildrenCheckbox = _this.state.childrenCheckbox.map(function (checkbox) {
          return _extends({}, checkbox, {
            checked: !checked
          });
        });

        _this.setState({
          childrenCheckbox: newChildrenCheckbox
        });
      };
    };

    _this._createHandleChangeChildren = function (index) {
      return function () {
        var childrenCheckbox = _this.state.childrenCheckbox;
        var newChildrenCheckbox = childrenCheckbox.map(function (checkbox, checkboxIndex) {
          if (checkboxIndex === index) {
            return _extends({}, checkbox, {
              checked: !checkbox.checked
            });
          }

          return checkbox;
        });

        _this.setState({
          childrenCheckbox: newChildrenCheckbox
        });
      };
    };

    return _this;
  }

  var _proto = FormCheckboxesWithParent.prototype;

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.props.handleUpdateCheckboxes(this.state.childrenCheckbox);
  };

  _proto.render = function render() {
    var _this2 = this;

    var parentCheckbox = this.props.parentCheckbox;
    var childrenCheckbox = this.state.childrenCheckbox;
    var checked = childrenCheckbox.every(function (checkbox) {
      return checkbox.checked;
    });
    return /*#__PURE__*/_jsxs("div", {
      className: BASE_CLASS,
      children: [/*#__PURE__*/_jsx(FormCheckbox, {
        name: parentCheckbox.name,
        checked: checked,
        onChange: this._createHandleChangeParent(checked),
        label: parentCheckbox.label
      }), /*#__PURE__*/_jsx("div", {
        className: BASE_CLASS + "-children",
        children: childrenCheckbox.map(function (checkbox, index) {
          return /*#__PURE__*/_jsx(FormCheckbox, {
            name: checkbox.name,
            checked: checkbox.checked,
            onChange: _this2._createHandleChangeChildren(index),
            label: checkbox.label
          }, index);
        })
      })]
    });
  };

  return FormCheckboxesWithParent;
}(PureComponent);

FormCheckboxesWithParent.displayName = 'FormCheckboxesWithParent';
FormCheckboxesWithParent.defaultProps = {
  handleUpdateCheckboxes: function handleUpdateCheckboxes() {}
};
export default FormCheckboxesWithParent;